Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/tesselation.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -3871,11 +2721,9 @@
 
   // construct one orthogonal vector
-  if (Reference != NULL) {
-    AngleZero = (*Reference) - (*Point->node);
-    AngleZero.ProjectOntoPlane(PlaneNormal);
-  }
-  if ((Reference == NULL) || (AngleZero.NormSquared() < MYEPSILON)) {
-    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl);
-    AngleZero = (*(*SetOfNeighbours->begin())->node) - (*Point->node);
+  AngleZero = (Reference) - (Point->getPosition());
+  AngleZero.ProjectOntoPlane(PlaneNormal);
+  if ((AngleZero.NormSquared() < MYEPSILON)) {
+    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer." << endl);
+    AngleZero = ((*SetOfNeighbours->begin())->getPosition()) - (Point->getPosition());
     AngleZero.ProjectOntoPlane(PlaneNormal);
     if (AngleZero.NormSquared() < MYEPSILON) {
@@ -3893,5 +2741,5 @@
   // go through all connected points and calculate angle
   for (TesselPointSet::iterator listRunner = SetOfNeighbours->begin(); listRunner != SetOfNeighbours->end(); listRunner++) {
-    helper = (*(*listRunner)->node) - (*Point->node);
+    helper = ((*listRunner)->getPosition()) - (Point->getPosition());
     helper.ProjectOntoPlane(PlaneNormal);
     double angle = GetAngle(helper, AngleZero, OrthogonalVector);
@@ -3915,8 +2763,8 @@
  * @param *SetOfNeighbours all points for which the angle should be calculated
  * @param *Point of which get all connected points
- * @param *Reference Reference vector for zero angle or NULL for no preference
+ * @param *Reference Reference vector for zero angle or (0,0,0) for no preference
  * @return list of the all points linked to the provided one
  */
-TesselPointList * Tesselation::GetCircleOfSetOfPoints(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector * const Reference) const
+TesselPointList * Tesselation::GetCircleOfSetOfPoints(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector &Reference) const
 {
   Info FunctionInfo(__func__);
@@ -3942,5 +2790,5 @@
   }
 
-  DoLog(1) && (Log() << Verbose(1) << "INFO: Point is " << *Point << " and Reference is " << *Reference << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Point is " << *Point << " and Reference is " << Reference << "." << endl);
   // calculate central point
   TesselPointSet::const_iterator TesselA = SetOfNeighbours->begin();
@@ -3952,7 +2800,7 @@
   int counter = 0;
   while (TesselC != SetOfNeighbours->end()) {
-    helper = Plane(*((*TesselA)->node),
-                   *((*TesselB)->node),
-                   *((*TesselC)->node)).getNormal();
+    helper = Plane(((*TesselA)->getPosition()),
+                   ((*TesselB)->getPosition()),
+                   ((*TesselC)->getPosition())).getNormal();
     DoLog(0) && (Log() << Verbose(0) << "Making normal vector out of " << *(*TesselA) << ", " << *(*TesselB) << " and " << *(*TesselC) << ":" << helper << endl);
     counter++;
@@ -3974,11 +2822,11 @@
 
   // construct one orthogonal vector
-  if (Reference != NULL) {
-    AngleZero = (*Reference) - (*Point->node);
+  if (!Reference.IsZero()) {
+    AngleZero = (Reference) - (Point->getPosition());
     AngleZero.ProjectOntoPlane(PlaneNormal);
   }
-  if ((Reference == NULL) || (AngleZero.NormSquared() < MYEPSILON )) {
-    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl);
-    AngleZero = (*(*SetOfNeighbours->begin())->node) - (*Point->node);
+  if ((Reference.IsZero()) || (AngleZero.NormSquared() < MYEPSILON )) {
+    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer." << endl);
+    AngleZero = ((*SetOfNeighbours->begin())->getPosition()) - (Point->getPosition());
     AngleZero.ProjectOntoPlane(PlaneNormal);
     if (AngleZero.NormSquared() < MYEPSILON) {
@@ -3997,5 +2845,5 @@
   pair<map<double, TesselPoint*>::iterator, bool> InserterTest;
   for (TesselPointSet::iterator listRunner = SetOfNeighbours->begin(); listRunner != SetOfNeighbours->end(); listRunner++) {
-    helper = (*(*listRunner)->node) - (*Point->node);
+    helper = ((*listRunner)->getPosition()) - (Point->getPosition());
     helper.ProjectOntoPlane(PlaneNormal);
     double angle = GetAngle(helper, AngleZero, OrthogonalVector);
@@ -4242,5 +3090,5 @@
 
   // copy old location for the volume
-  OldPoint = (*point->node->node);
+  OldPoint = (point->node->getPosition());
 
   // get list of connected points
@@ -4305,5 +3153,5 @@
           StartNode--;
           //Log() << Verbose(3) << "INFO: StartNode is " << **StartNode << "." << endl;
-          Point = (*(*StartNode)->node) - (*(*MiddleNode)->node);
+          Point = ((*StartNode)->getPosition()) - ((*MiddleNode)->getPosition());
           StartNode = MiddleNode;
           StartNode++;
@@ -4311,6 +3159,6 @@
             StartNode = connectedPath->begin();
           //Log() << Verbose(3) << "INFO: EndNode is " << **StartNode << "." << endl;
-          Reference = (*(*StartNode)->node) - (*(*MiddleNode)->node);
-          OrthogonalVector = (*(*MiddleNode)->node) - OldPoint;
+          Reference = ((*StartNode)->getPosition()) - ((*MiddleNode)->getPosition());
+          OrthogonalVector = ((*MiddleNode)->getPosition()) - OldPoint;
           OrthogonalVector.MakeNormalTo(Reference);
           angle = GetAngle(Point, Reference, OrthogonalVector);
@@ -4367,5 +3215,5 @@
         AddTesselationTriangle();
         // calculate volume summand as a general tetraeder
-        volume += CalculateVolumeofGeneralTetraeder(*TPS[0]->node->node, *TPS[1]->node->node, *TPS[2]->node->node, OldPoint);
+        volume += CalculateVolumeofGeneralTetraeder(TPS[0]->node->getPosition(), TPS[1]->node->getPosition(), TPS[2]->node->getPosition(), OldPoint);
         // advance number
         count++;
@@ -4752,5 +3600,5 @@
   // find nearest boundary point
   class TesselPoint *BackupPoint = NULL;
-  class TesselPoint *NearestPoint = FindClosestTesselPoint(point->node, BackupPoint, LC);
+  class TesselPoint *NearestPoint = FindClosestTesselPoint(point->getPosition(), BackupPoint, LC);
   class BoundaryPointSet *NearestBoundaryPoint = NULL;
   PointMap::iterator PointRunner;
@@ -4773,9 +3621,9 @@
   class BoundaryLineSet *BestLine = NULL;
   for (LineMap::iterator Runner = NearestBoundaryPoint->lines.begin(); Runner != NearestBoundaryPoint->lines.end(); Runner++) {
-    BaseLine = (*Runner->second->endpoints[0]->node->node) -
-               (*Runner->second->endpoints[1]->node->node);
-    CenterToPoint = 0.5 * ((*Runner->second->endpoints[0]->node->node) +
-                           (*Runner->second->endpoints[1]->node->node));
-    CenterToPoint -= (*point->node);
+    BaseLine = (Runner->second->endpoints[0]->node->getPosition()) -
+               (Runner->second->endpoints[1]->node->getPosition());
+    CenterToPoint = 0.5 * ((Runner->second->endpoints[0]->node->getPosition()) +
+                           (Runner->second->endpoints[1]->node->getPosition()));
+    CenterToPoint -= (point->getPosition());
     angle = CenterToPoint.Angle(BaseLine);
     if (fabs(angle - M_PI/2.) < fabs(BestAngle - M_PI/2.)) {
Index: src/tesselation.hpp
===================================================================
--- src/tesselation.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/tesselation.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -2,5 +2,6 @@
  * tesselation.hpp
  *
- *  The tesselation class is meant to contain the envelope (concave, convex or neither) of a set of Vectors. As we actually mean this stuff for atoms, we have to encapsulate it all a bit.
+ *  The tesselation class is meant to contain the envelope (concave, convex or neither) of a set of Vectors.
+ *  As we actually mean this stuff for atoms, we have to encapsulate it all a bit.
  *
  *  Created on: Aug 3, 2009
@@ -25,7 +26,12 @@
 #include <stack>
 
+#include "BoundaryMaps.hpp"
+#include "BoundaryPointSet.hpp"
+#include "PointCloud.hpp"
+#include "TesselPoint.hpp"
 #include "atom_particleinfo.hpp"
-#include "helpers.hpp"
-#include "vector.hpp"
+#include "Helpers/helpers.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
 
 /****************************************** forward declarations *****************************/
@@ -34,7 +40,6 @@
 class BoundaryLineSet;
 class BoundaryTriangleSet;
+class CandidateForTesselation;
 class LinkedCell;
-class TesselPoint;
-class PointCloud;
 class Tesselation;
 class Plane;
@@ -42,238 +47,17 @@
 /********************************************** definitions *********************************/
 
-#define DoTecplotOutput 1
-#define DoRaster3DOutput 1
-#define DoVRMLOutput 0
-#define TecplotSuffix ".dat"
-#define Raster3DSuffix ".r3d"
-#define VRMLSUffix ".wrl"
+enum { DoTecplotOutput=1 };
+enum { DoRaster3DOutput=1 };
+enum { DoVRMLOutput=0 };
 
-#define ParallelEpsilon 1e-3
+extern "C" const char *TecplotSuffix;
+extern "C" const char *Raster3DSuffix;
+extern "C" const char *VRMLSUffix;
+
+extern "C" const double ParallelEpsilon;
 
 // ======================================================= some template functions =========================================
 
-#define IndexToIndex map <int, int>
-
-#define PointMap map < int, class BoundaryPointSet * >
-#define PointSet set < class BoundaryPointSet * >
-#define PointList list < class BoundaryPointSet * >
-#define PointPair pair < int, class BoundaryPointSet * >
-#define PointTestPair pair < PointMap::iterator, bool >
-
-#define CandidateList list <class CandidateForTesselation *>
-#define CandidateMap map <class BoundaryLineSet *, class CandidateForTesselation *>
-
-#define LineMap multimap < int, class BoundaryLineSet * >
-#define LineSet set < class BoundaryLineSet * >
-#define LineList list < class BoundaryLineSet * >
-#define LinePair pair < int, class BoundaryLineSet * >
-#define LineTestPair pair < LineMap::iterator, bool >
-
-#define TriangleMap map < int, class BoundaryTriangleSet * >
-#define TriangleSet set < class BoundaryTriangleSet * >
-#define TriangleList list < class BoundaryTriangleSet * >
-#define TrianglePair pair < int, class BoundaryTriangleSet * >
-#define TriangleTestPair pair < TrianglePair::iterator, bool >
-
-#define PolygonMap map < int, class BoundaryPolygonSet * >
-#define PolygonSet set < class BoundaryPolygonSet * >
-#define PolygonList list < class BoundaryPolygonSet * >
-
-#define DistanceToPointMap multimap <double, class BoundaryPointSet * >
-#define DistanceToPointPair pair <double, class BoundaryPointSet * >
-
-#define DistanceMultiMap multimap <double, pair < PointMap::iterator, PointMap::iterator> >
-#define DistanceMultiMapPair pair <double, pair < PointMap::iterator, PointMap::iterator> >
-
-#define TesselPointList list <TesselPoint *>
-#define TesselPointSet set <TesselPoint *>
-
-#define ListOfTesselPointList list<list <TesselPoint *> *>
-
-enum centers {Opt, OtherOpt};
-
 /********************************************** declarations *******************************/
-
-template <typename T> void SetEndpointsOrdered(T endpoints[2], T endpoint1, T endpoint2)
-{
-  if (endpoint1->Nr < endpoint2->Nr) {
-    endpoints[0] = endpoint1;
-    endpoints[1] = endpoint2;
-  } else {
-    endpoints[0] = endpoint2;
-    endpoints[1] = endpoint1;
-  }
-};
-
-// ======================================================== class BoundaryPointSet =========================================
-
-class BoundaryPointSet {
-  public:
-    BoundaryPointSet();
-    BoundaryPointSet(TesselPoint * const Walker);
-    ~BoundaryPointSet();
-
-    void AddLine(BoundaryLineSet * const line);
-
-    LineMap lines;
-    int LinesCount;
-    TesselPoint *node;
-    double value;
-    int Nr;
-};
-
-ostream & operator << (ostream &ost, const BoundaryPointSet &a);
-
-// ======================================================== class BoundaryLineSet ==========================================
-
-class BoundaryLineSet {
-  public:
-    BoundaryLineSet();
-    BoundaryLineSet(BoundaryPointSet * const Point[2], const int number);
-    BoundaryLineSet(BoundaryPointSet * const Point1, BoundaryPointSet * const Point2, const int number);
-    ~BoundaryLineSet();
-
-    void AddTriangle(BoundaryTriangleSet * const triangle);
-    bool IsConnectedTo(const BoundaryLineSet * const line) const;
-    bool ContainsBoundaryPoint(const BoundaryPointSet * const point) const;
-    bool CheckConvexityCriterion() const;
-    double CalculateConvexity() const;
-    class BoundaryPointSet *GetOtherEndpoint(const BoundaryPointSet * const point) const;
-    class BoundaryTriangleSet *GetOtherTriangle(const BoundaryTriangleSet * const triangle) const;
-
-    class BoundaryPointSet *endpoints[2];
-    TriangleMap triangles;
-    int Nr;
-    bool skipped;
-};
-
-ostream & operator << (ostream &ost, const BoundaryLineSet &a);
-
-// ======================================================== class BoundaryTriangleSet =======================================
-
-class BoundaryTriangleSet {
-  public:
-    BoundaryTriangleSet();
-    BoundaryTriangleSet(class BoundaryLineSet * const line[3], const int number);
-    ~BoundaryTriangleSet();
-
-    void GetNormalVector(const Vector &NormalVector);
-    void GetCenter(Vector * const center) const;
-    bool GetIntersectionInsideTriangle(const Vector * const MolCenter, const Vector * const x, Vector * const Intersection) const;
-    double GetClosestPointInsideTriangle(const Vector * const x, Vector * const ClosestPoint) const;
-    bool ContainsBoundaryLine(const BoundaryLineSet * const line) const;
-    bool ContainsBoundaryPoint(const BoundaryPointSet * const point) const;
-    bool ContainsBoundaryPoint(const TesselPoint * const point) const;
-    class BoundaryPointSet *GetThirdEndpoint(const BoundaryLineSet * const line) const;
-    class BoundaryLineSet *GetThirdLine(const BoundaryPointSet * const point) const;
-    bool IsPresentTupel(const BoundaryPointSet * const Points[3]) const;
-    bool IsPresentTupel(const BoundaryTriangleSet * const T) const;
-
-    Plane getPlane() const;
-    Vector getEndpoint(int) const;
-    std::string getEndpointName(int) const;
-
-    class BoundaryPointSet *endpoints[3];
-    class BoundaryLineSet *lines[3];
-    Vector NormalVector;
-    Vector SphereCenter;
-    int Nr;
-
-  private:
-
-};
-
-ostream & operator << (ostream &ost, const BoundaryTriangleSet &a);
-
-
-// ======================================================== class BoundaryTriangleSet =======================================
-
-/** Set of BoundaryPointSet.
- * This is just meant as a container for a group of endpoints, extending the node, line, triangle concept. However, this has
- * only marginally something to do with the tesselation. Hence, there is no incorporation into the bookkeeping of the Tesselation
- * class (i.e. no allocation, no deletion).
- * \note we assume that the set of endpoints reside (more or less) on a plane.
- */
-class BoundaryPolygonSet {
-  public:
-    BoundaryPolygonSet();
-    ~BoundaryPolygonSet();
-
-    Vector * GetNormalVector(const Vector &NormalVector) const;
-    void GetCenter(Vector *center) const;
-    bool ContainsBoundaryLine(const BoundaryLineSet * const line) const;
-    bool ContainsBoundaryPoint(const BoundaryPointSet * const point) const;
-    bool ContainsBoundaryPoint(const TesselPoint * const point) const;
-    bool ContainsBoundaryTriangle(const BoundaryTriangleSet * const point) const;
-    bool ContainsPresentTupel(const BoundaryPointSet * const * Points, const int dim) const;
-    bool ContainsPresentTupel(const BoundaryPolygonSet * const P) const;
-    bool ContainsPresentTupel(const PointSet &endpoints) const;
-    TriangleSet * GetAllContainedTrianglesFromEndpoints() const;
-    bool FillPolygonFromTrianglesOfLine(const BoundaryLineSet * const line);
-
-    PointSet endpoints;
-    int Nr;
-};
-
-ostream & operator << (ostream &ost, const BoundaryPolygonSet &a);
-
-// =========================================================== class TESSELPOINT ===========================================
-
-/** Is a single point of the set of Vectors, also a super-class to be inherited and and its functions to be implemented.
- */
-class TesselPoint : virtual public ParticleInfo {
-public:
-  TesselPoint();
-  virtual ~TesselPoint();
-
-  Vector *node;   // pointer to position of the dot in space
-
-  virtual ostream & operator << (ostream &ost);
-};
-
-ostream & operator << (ostream &ost, const TesselPoint &a);
-
-// =========================================================== class POINTCLOUD ============================================
-
-/** Super-class for all point clouds structures, also molecules. They have to inherit this structure and implement the virtual function to access the Vectors.
- * This basically encapsulates a list structure.
- */
-class PointCloud {
-public:
-  PointCloud();
-  virtual ~PointCloud();
-
-  virtual const char * const GetName() const { return "unknown"; };
-  virtual Vector *GetCenter() const { return NULL; };
-  virtual TesselPoint *GetPoint() const { return NULL; };
-  virtual int GetMaxId() const { return 0; };
-  virtual void GoToNext() const {};
-  virtual void GoToFirst() const {};
-  virtual bool IsEmpty() const { return true; };
-  virtual bool IsEnd() const { return true; };
-};
-
-// ======================================================== class CandidateForTesselation =========================================
-
-class CandidateForTesselation {
-  public :
-  CandidateForTesselation(BoundaryLineSet* currentBaseLine);
-  CandidateForTesselation(TesselPoint* candidate, BoundaryLineSet* currentBaseLine, BoundaryPointSet *point, Vector OptCandidateCenter, Vector OtherOptCandidateCenter);
-  ~CandidateForTesselation();
-
-  bool CheckValidity(const double RADIUS, const LinkedCell *LC) const;
-
-  TesselPointList pointlist;
-  const BoundaryLineSet * BaseLine;
-  const BoundaryPointSet * ThirdPoint;
-  const BoundaryTriangleSet *T;
-  Vector OldCenter;
-  Vector OptCenter;
-  Vector OtherOptCenter;
-  double ShortestAngle;
-  double OtherShortestAngle;
-};
-
-ostream & operator <<(ostream &ost, const  CandidateForTesselation &a);
 
 // =========================================================== class TESSELATION ===========================================
@@ -289,5 +73,5 @@
     void AddTesselationPoint(TesselPoint* Candidate, const int n);
     void SetTesselationPoint(TesselPoint* Candidate, const int n) const;
-    void AddTesselationLine(const Vector * const OptCenter, const BoundaryPointSet * const candidate, class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
+    void AddTesselationLine(const Vector * OptCenter, const BoundaryPointSet * const candidate, class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
     void AddNewTesselationTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
     void AddExistingTesselationTriangleLine(class BoundaryLineSet *FindLine, int n);
@@ -330,10 +114,10 @@
     ListOfTesselPointList * GetPathsOfConnectedPoints(const TesselPoint* const Point) const;
     ListOfTesselPointList * GetClosedPathsOfConnectedPoints(const TesselPoint* const Point) const;
-    TesselPointList * GetCircleOfSetOfPoints(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector * const Reference = NULL) const;
-    TesselPointList * GetCircleOfConnectedTriangles(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector * const Reference) const;
+    TesselPointList * GetCircleOfSetOfPoints(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector &Reference) const;
+    TesselPointList * GetCircleOfConnectedTriangles(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector &Reference) const;
     class BoundaryPointSet * GetCommonEndpoint(const BoundaryLineSet * line1, const BoundaryLineSet * line2) const;
     TriangleList * FindTriangles(const TesselPoint* const Points[3]) const;
-    TriangleList * FindClosestTrianglesToVector(const Vector *x, const LinkedCell* LC) const;
-    BoundaryTriangleSet * FindClosestTriangleToVector(const Vector *x, const LinkedCell* LC) const;
+    TriangleList * FindClosestTrianglesToVector(const Vector &x, const LinkedCell* LC) const;
+    BoundaryTriangleSet * FindClosestTriangleToVector(const Vector &x, const LinkedCell* LC) const;
     bool IsInnerPoint(const Vector &Point, const LinkedCell* const LC) const;
     double GetDistanceSquaredToTriangle(const Vector &Point, const BoundaryTriangleSet* const triangle) const;
@@ -341,6 +125,6 @@
     BoundaryTriangleSet * GetClosestTriangleOnSurface(const Vector &Point, const LinkedCell* const LC) const;
     bool AddBoundaryPoint(TesselPoint * Walker, const int n);
-    DistanceToPointMap * FindClosestBoundaryPointsToVector(const Vector *x, const LinkedCell* LC) const;
-    BoundaryLineSet * FindClosestBoundaryLineToVector(const Vector *x, const LinkedCell* LC) const;
+    DistanceToPointMap * FindClosestBoundaryPointsToVector(const Vector &x, const LinkedCell* LC) const;
+    BoundaryLineSet * FindClosestBoundaryLineToVector(const Vector &x, const LinkedCell* LC) const;
 
     // print for debugging
@@ -360,4 +144,12 @@
     int TrianglesOnBoundaryCount;
 
+    typedef PointMap::iterator iterator;
+    typedef PointMap::const_iterator const_iterator;
+    TesselPoint * getValue(const_iterator &rhs) const;
+    TesselPoint * getValue(iterator &rhs) const;
+    iterator begin() { return PointsOnBoundary.begin(); }
+    const_iterator begin() const { return PointsOnBoundary.begin(); }
+    iterator end() { return PointsOnBoundary.end(); }
+    const_iterator end() const { return PointsOnBoundary.end(); }
     // PointCloud implementation for PointsOnBoundary
     virtual Vector *GetCenter(ofstream *out) const;
@@ -375,4 +167,6 @@
 
   private:
+    static const double HULLEPSILON; //!< TODO: Get rid of HULLEPSILON, points to numerical instabilities
+
     mutable class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
 
